/*
**	Copyright (c) 1995, Sebastian Schoenberg 
**	E-mail : ss10@irz.inf.tu-dresden.de
**
**	University of Technology Dresden, Department of Computer Science
**	Inistute for Operating Systems, Databases and Computer Networks
**
**	$Id: head.S,v 4.0 1998/01/12 16:07:23 schoenbg Exp $
**
**	$Log: head.S,v $
**	Revision 4.0  1998/01/12 16:07:23  schoenbg
**	Revision 4.0
**
**	Revision 1.1  1997/04/30 15:33:51  schoenbg
**	IRQs can now be associated and received via IRQ
**
**	some bugs fixed.
**
**	Revision 1.1.1.1  1997/01/13 15:56:48  schoenbg
**	L4 for ALpha 21164
**	
**
*/


#include <regdef.h>


#define STACKSIZE	4096
		
	.text
	.align	3

        .globl  start
	
        .ent    start
 
start:
	bis	zero, zero, zero
	br	pv, 1f
	
1:	ldgp    gp, 0(pv)		# Need a gp, for bootstrap
	nop
	lda	sp, _stack
	lda	sp, 0x1000 (sp)
	bis	a0, zero, a1
	bis	sp, zero, a0
	lda     pv, main
	jsr     ra, (pv), main
	
2:	
	.long	0x93
	br	zero, 2b

	.end	start


	
	.align	3
	.lcomm	_stack, STACKSIZE
	.lcomm	_stack_end, 8
	
	







